/*******************************************************************************
 * FoxObjectPool generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxObjectPool extends Actor
    native
    notplaceable
    hidecategories(Navigation);

const MAX_EMITTERS = 100;
const MAX_KACTORS = 20;
const MAX_TRACERS = 20;
const MAX_TEAM_BEACONS = 6;

struct native EmitterCacheType
{
    var int ListIndex;
    var int NumActiveEmitters;
    var EmitterSpawnable List[100];

    structdefaultproperties
    {
        ListIndex=0
        NumActiveEmitters=0
        List[0]=none
        List[1]=none
        List[2]=none
        List[3]=none
        List[4]=none
        List[5]=none
        List[6]=none
        List[7]=none
        List[8]=none
        List[9]=none
        List[10]=none
        List[11]=none
        List[12]=none
        List[13]=none
        List[14]=none
        List[15]=none
        List[16]=none
        List[17]=none
        List[18]=none
        List[19]=none
        List[20]=none
        List[21]=none
        List[22]=none
        List[23]=none
        List[24]=none
        List[25]=none
        List[26]=none
        List[27]=none
        List[28]=none
        List[29]=none
        List[30]=none
        List[31]=none
        List[32]=none
        List[33]=none
        List[34]=none
        List[35]=none
        List[36]=none
        List[37]=none
        List[38]=none
        List[39]=none
        List[40]=none
        List[41]=none
        List[42]=none
        List[43]=none
        List[44]=none
        List[45]=none
        List[46]=none
        List[47]=none
        List[48]=none
        List[49]=none
        List[50]=none
        List[51]=none
        List[52]=none
        List[53]=none
        List[54]=none
        List[55]=none
        List[56]=none
        List[57]=none
        List[58]=none
        List[59]=none
        List[60]=none
        List[61]=none
        List[62]=none
        List[63]=none
        List[64]=none
        List[65]=none
        List[66]=none
        List[67]=none
        List[68]=none
        List[69]=none
        List[70]=none
        List[71]=none
        List[72]=none
        List[73]=none
        List[74]=none
        List[75]=none
        List[76]=none
        List[77]=none
        List[78]=none
        List[79]=none
        List[80]=none
        List[81]=none
        List[82]=none
        List[83]=none
        List[84]=none
        List[85]=none
        List[86]=none
        List[87]=none
        List[88]=none
        List[89]=none
        List[90]=none
        List[91]=none
        List[92]=none
        List[93]=none
        List[94]=none
        List[95]=none
        List[96]=none
        List[97]=none
        List[98]=none
        List[99]=none
    }
};

struct native KActorCacheType
{
    var int ListIndex;
    var KActorSpawnable List[20];

    structdefaultproperties
    {
        ListIndex=0
        List[0]=none
        List[1]=none
        List[2]=none
        List[3]=none
        List[4]=none
        List[5]=none
        List[6]=none
        List[7]=none
        List[8]=none
        List[9]=none
        List[10]=none
        List[11]=none
        List[12]=none
        List[13]=none
        List[14]=none
        List[15]=none
        List[16]=none
        List[17]=none
        List[18]=none
        List[19]=none
    }
};

struct native TracerCacheType
{
    var int ListIndex;
    var FoxProjectile_Tracer List[20];

    structdefaultproperties
    {
        ListIndex=0
        List[0]=none
        List[1]=none
        List[2]=none
        List[3]=none
        List[4]=none
        List[5]=none
        List[6]=none
        List[7]=none
        List[8]=none
        List[9]=none
        List[10]=none
        List[11]=none
        List[12]=none
        List[13]=none
        List[14]=none
        List[15]=none
        List[16]=none
        List[17]=none
        List[18]=none
        List[19]=none
    }
};

struct native DecalDatum
{
    var export editinline FoxDecalComponent FD;
    var float SpawnTime;
    var Vector SpawnLoc;
    var float CanSpawnDistance;

    structdefaultproperties
    {
        FD=none
        SpawnTime=0.0
        SpawnLoc=(X=0.0,Y=0.0,Z=0.0)
        CanSpawnDistance=0.0
    }
};

struct native DecalPool
{
    var int MAX_DECALS;
    var int MAX_DECALS_bDropDetail;
    var int MAX_DECALS_bAggressiveLOD;
    var array<DecalDatum> Decals;
    var transient int DecalsIdx;

    structdefaultproperties
    {
        MAX_DECALS=0
        MAX_DECALS_bDropDetail=0
        MAX_DECALS_bAggressiveLOD=0
        Decals=none
        DecalsIdx=0
    }
};

struct native TeamBeaconCacheType
{
    var int ListIndex;
    var FoxTeamBeacon Beacons[6];

    structdefaultproperties
    {
        ListIndex=0
        Beacons[0]=none
        Beacons[1]=none
        Beacons[2]=none
        Beacons[3]=none
        Beacons[4]=none
        Beacons[5]=none
    }
};

var() EmitterCacheType EmitterCache;
var KActorCacheType KActorCache;
var TracerCacheType TracerCache;
var DecalPool DecalPool_Bullet;
var TeamBeaconCacheType TeamBeaconCache;

simulated event PreBeginPlay()
{
    CreatePools();
    //return;    
}

final simulated function CreatePools()
{
    CreateDecals();
    //return;    
}

function Destroyed()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xB2 [Loop If]
    if(I < 6)
    {
        // End:0x7C
        if(TeamBeaconCache.Beacons[I] != none)
        {
            TeamBeaconCache.Beacons[I].Destroy();
        }
        TeamBeaconCache.Beacons[I] = none;
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    I = 0;
    J0xBD:
    // End:0x190 [Loop If]
    if(I < 100)
    {
        // End:0x182
        if(EmitterCache.List[I] != none)
        {
            // End:0x15A
            if(EmitterCache.List[I] != none)
            {
                EmitterCache.List[I].Destroy();
            }
            EmitterCache.List[I] = none;
        }
        ++ I;
        // [Loop Continue]
        goto J0xBD;
    }
    I = 0;
    J0x19B:
    // End:0x242 [Loop If]
    if(I < 20)
    {
        // End:0x20C
        if(KActorCache.List[I] != none)
        {
            KActorCache.List[I].Destroy();
        }
        KActorCache.List[I] = none;
        ++ I;
        // [Loop Continue]
        goto J0x19B;
    }
    I = 0;
    J0x24D:
    // End:0x2F4 [Loop If]
    if(I < 20)
    {
        // End:0x2BE
        if(TracerCache.List[I] != none)
        {
            TracerCache.List[I].Destroy();
        }
        TracerCache.List[I] = none;
        ++ I;
        // [Loop Continue]
        goto J0x24D;
    }
    CleanupDecals();
    super.Destroyed();
    //return;    
}

final simulated function EmitterSpawnable GetEmitter(ParticleSystem PSTemplate, Vector NewLocation, Rotator NewRotation)
{
    local int I;

    EmitterCache.ListIndex = (EmitterCache.ListIndex + 1) % 100;
    // End:0xEF
    if(EmitterCache.List[EmitterCache.ListIndex] == none)
    {
        CreateEmitter(EmitterCache.ListIndex, PSTemplate);
        // End:0xEF
        if(EmitterCache.List[EmitterCache.ListIndex] == none)
        {
            return none;
        }
    }
    EmitterCache.List[EmitterCache.ListIndex].bCurrentlyActive = true;
    EmitterCache.List[EmitterCache.ListIndex].SetBase(none);
    EmitterCache.List[EmitterCache.ListIndex].ParticleSystemComponent.__OnSystemFinished__Delegate = EmitterCache.List[EmitterCache.ListIndex].OnParticleSystemFinished;
    EmitterCache.List[EmitterCache.ListIndex].SetLocation(NewLocation);
    EmitterCache.List[EmitterCache.ListIndex].SetRotation(NewRotation);
    EmitterCache.List[EmitterCache.ListIndex].bPostUpdateTickGroup = false;
    EmitterCache.List[EmitterCache.ListIndex].bShouldTick = true;
    // End:0x559
    if(PSTemplate != none)
    {
        EmitterCache.List[EmitterCache.ListIndex].SetTemplate(PSTemplate, false);
        I = 0;
        J0x3FD:
        // End:0x559 [Loop If]
        if(I < EmitterCache.List[EmitterCache.ListIndex].ParticleSystemComponent.EmitterInstances.Length)
        {
            EmitterCache.List[EmitterCache.ListIndex].ParticleSystemComponent.SetKillOnDeactivate(I, false);
            EmitterCache.List[EmitterCache.ListIndex].ParticleSystemComponent.SetKillOnCompleted(I, false);
            ++ I;
            // [Loop Continue]
            goto J0x3FD;
        }
    }
    EmitterCache.List[EmitterCache.ListIndex].SetHidden(false);
    EmitterCache.List[EmitterCache.ListIndex].SetDrawScale(1.0);
    return EmitterCache.List[EmitterCache.ListIndex];
    //return ReturnValue;    
}

final simulated function CreateEmitter(int EffectIndex, ParticleSystem PSTemplate)
{
    local int I;

    // End:0x6C
    if(EmitterCache.List[EffectIndex] == none)
    {
        EmitterCache.List[EffectIndex] = Spawn(class'FoxEmitterSpawnable');
    }
    // End:0x9A
    if(EmitterCache.List[EffectIndex] == none)
    {
        return;
    }
    EmitterCache.List[EffectIndex].LifeSpan = 0.0;
    EmitterCache.List[EffectIndex].bDestroyOnSystemFinish = false;
    EmitterCache.List[EffectIndex].ParticleSystemComponent.DeactivateSystem();
    EmitterCache.List[EffectIndex].SetHidden(true);
    EmitterCache.List[EffectIndex].bCurrentlyActive = false;
    EmitterCache.List[EffectIndex].ParticleSystemComponent.bAutoActivate = false;
    EmitterCache.List[EffectIndex].SetTemplate(PSTemplate, false);
    I = 0;
    J0x289:
    // End:0x3AC [Loop If]
    if(I < EmitterCache.List[EffectIndex].ParticleSystemComponent.EmitterInstances.Length)
    {
        EmitterCache.List[EffectIndex].ParticleSystemComponent.SetKillOnDeactivate(I, false);
        EmitterCache.List[EffectIndex].ParticleSystemComponent.SetKillOnCompleted(I, false);
        ++ I;
        // [Loop Continue]
        goto J0x289;
    }
    //return;    
}

final simulated function CreateKActor(int KActorIndex, Vector SpawnLocation, Rotator SpawnRotation)
{
    // End:0x7C
    if(KActorCache.List[KActorIndex] == none)
    {
        KActorCache.List[KActorIndex] = Spawn(class'KActorSpawnable',,, SpawnLocation, SpawnRotation);
    }
    // End:0xAA
    if(EmitterCache.List[KActorIndex] == none)
    {
        return;
    }
    KActorCache.List[KActorIndex].RemoteRole = ROLE_None;
    KActorCache.List[KActorIndex].SetCollision(false, false);
    KActorCache.List[KActorIndex].bCollideWorld = false;
    KActorCache.List[KActorIndex].bBlocksNavigation = false;
    KActorCache.List[KActorIndex].bNoEncroachCheck = true;
    KActorCache.List[KActorIndex].LightEnvironment.SetEnabled(false);
    KActorCache.List[KActorIndex].LightEnvironment.bCastShadows = false;
    KActorCache.List[KActorIndex].StaticMeshComponent.CastShadow = false;
    KActorCache.List[KActorIndex].StaticMeshComponent.SetLightEnvironment(KActorCache.List[KActorIndex].LightEnvironment);
    KActorCache.List[KActorIndex].Recycle();
    KActorCache.List[KActorIndex].bRecycleScaleToZero = true;
    //return;    
}

final simulated function KActorSpawnable GetKActorSpawnable(Vector SpawnLocation, Rotator SpawnRotation, optional float Lifetime)
{
    local int Idx;
    local KActorSpawnable KA;

    Lifetime = 0.0;
    KActorCache.ListIndex = (KActorCache.ListIndex + 1) % 20;
    // End:0x101
    if(KActorCache.List[KActorCache.ListIndex] == none)
    {
        CreateKActor(KActorCache.ListIndex, SpawnLocation, SpawnRotation);
        // End:0x101
        if(KActorCache.List[KActorCache.ListIndex] == none)
        {
            return none;
        }
    }
    KA = KActorCache.List[KActorCache.ListIndex];
    // End:0x4C4
    if(KA != none)
    {
        // End:0x1C2
        if(KA.IsTimerActive('Recycle') || KA.bRecycleScaleToZero)
        {
            KA.RecycleInternal();
        }
        KA.LightEnvironment.bDynamic = true;
        KA.LightEnvironment.SetEnabled(true);
        KA.SetCollision(false, false);
        KA.bCollideWorld = false;
        KA.bBlocksNavigation = false;
        KA.bNoEncroachCheck = true;
        KA.SetLocation(SpawnLocation);
        KA.SetRotation(SpawnRotation);
        KA.StaticMeshComponent.SetRBLinearVelocity(vect(0.0, 0.0, 0.0));
        KA.StaticMeshComponent.SetRBAngularVelocity(vect(0.0, 0.0, 0.0));
        KA.StaticMeshComponent.SetRBPosition(SpawnLocation);
        KA.StaticMeshComponent.SetRBRotation(SpawnRotation);
        Idx = 0;
        J0x3F8:
        // End:0x486 [Loop If]
        if(Idx < KA.StaticMeshComponent.Materials.Length)
        {
            KA.StaticMeshComponent.SetMaterial(Idx, none);
            ++ Idx;
            // [Loop Continue]
            goto J0x3F8;
        }
        KA.ResetComponents();
        KA.Initialize();
    }
    return KA;
    //return ReturnValue;    
}

simulated function FoxProjectile_Tracer GetTracer(Vector SpawnLocation, Rotator SpawnRotation, class<FoxProjectile_Tracer> TracerClass)
{
    local FoxProjectile_Tracer PBT;

    // End:0x11
    if(TracerClass == none)
    {
        return none;
    }
    TracerCache.ListIndex = (TracerCache.ListIndex + 1) % 20;
    // End:0xF7
    if(TracerCache.List[TracerCache.ListIndex] == none)
    {
        CreateTracer(TracerCache.ListIndex);
        // End:0xF7
        if(TracerCache.List[TracerCache.ListIndex] == none)
        {
            return none;
        }
    }
    PBT = TracerCache.List[TracerCache.ListIndex];
    PBT.SetLocation(SpawnLocation);
    PBT.SetRotation(SpawnRotation);
    PBT.SetPhysics(6);
    PBT.TracerParticleSystem.SetTemplate(TracerClass.default.ParticleSystemTemplate);
    return PBT;
    //return ReturnValue;    
}

simulated function CreateTracer(int EffectIndex)
{
    TracerCache.List[EffectIndex] = Spawn(class'FoxProjectile_Tracer');
    TracerCache.List[EffectIndex].Recycle();
    //return;    
}

final simulated function CreateDecals()
{
    local int Idx;
    local editinline FoxDecalComponent FD;
    local DecalDatum DD;

    DecalPool_Bullet.MAX_DECALS = 100;
    DecalPool_Bullet.MAX_DECALS_bDropDetail = 80;
    DecalPool_Bullet.MAX_DECALS_bAggressiveLOD = 60;
    Idx = 0;
    J0x68:
    // End:0x17E [Loop If]
    if(Idx < DecalPool_Bullet.MAX_DECALS)
    {
        FD = new (self) class'FoxDecalComponent';
        DecalPool_Bullet.Decals[DecalPool_Bullet.Decals.Length] = DD;
        DecalPool_Bullet.Decals[Idx].FD = FD;
        DecalPool_Bullet.Decals[Idx].CanSpawnDistance = 10.0;
        ++ Idx;
        // [Loop Continue]
        goto J0x68;
    }
    //return;    
}

final simulated function FoxDecalComponent GetDecal_Bullet(const out Vector SpawnLocation)
{
    return GetDecal_Worker(DecalPool_Bullet.DecalsIdx, DecalPool_Bullet, DecalPool_Bullet.Decals, SpawnLocation);
    //return ReturnValue;    
}

// Export UFoxObjectPool::execGetDecal_Worker(FFrame&, void* const)
private native final simulated function FoxDecalComponent GetDecal_Worker(out int CurrIdx, const out DecalPool TheDecalPool, out array<DecalDatum> DecalList, const out Vector SpawnLocation);

final simulated function CleanupDecals()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x161 [Loop If]
    if(I < DecalPool_Bullet.Decals.Length)
    {
        // End:0x153
        if(DecalPool_Bullet.Decals[I].FD != none)
        {
            DecalPool_Bullet.Decals[I].FD.ResetToDefaults();
            DecalPool_Bullet.Decals[I].FD.LifeSpan = 0.010;
            DecalPool_Bullet.Decals[I].FD = none;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function FoxTeamBeacon GetTeamBeacon(Vector NewLocation, Rotator NewRotation)
{
    TeamBeaconCache.ListIndex = (TeamBeaconCache.ListIndex + 1) % 6;
    // End:0xA5
    if(TeamBeaconCache.Beacons[TeamBeaconCache.ListIndex] == none)
    {
        CreateTeamBeacon(TeamBeaconCache.ListIndex);
    }
    TeamBeaconCache.Beacons[TeamBeaconCache.ListIndex].InitBeacon(NewLocation, NewRotation);
    return TeamBeaconCache.Beacons[TeamBeaconCache.ListIndex];
    //return ReturnValue;    
}

function CreateTeamBeacon(const int BeaconIndex)
{
    TeamBeaconCache.Beacons[BeaconIndex] = Spawn(class'FoxTeamBeacon');
    // End:0x6F
    if(TeamBeaconCache.Beacons[BeaconIndex] == none)
    {
        J0x6F:
    }
    // End:0x6F
    else
    {
    }
    //return;    
}
